@REM
@REM Copyright (c) 2021-2023, AlterBasics Technologies Pvt Ltd.
@REM
@REM All Rights Reserved.
@REM You may not use this file except in compliance with the License.
@REM
@REM You may obtain a copy of the License at
@REM
@REM https://colrows.com/license.txt
@REM

@echo off
set argC=0
set "TAB=   "
for %%x in (%*) do Set /A argC+=1
if %argc% == 0 goto showUsage
echo JAVA HOME %JAVA_HOME%
setlocal EnableDelayedExpansion
IF NOT DEFINED JAVA_HOME (
REM Run where command to find Java
for /f "tokens=*" %%i in ('where java') do (
	echo searching JAVA executable at %%i
	set "temp=%%i"
	echo !temp! | find "\bin\java.exe" >nul
if errorlevel 1 (
    REM the path does not have /bin\java.exe, SKIP
) else (
	rem Remove \bin\java.exe from myString
	SET "temp_java_home=!temp:\bin\java.exe=!"
	set "temp_java_home=!temp_java_home:\=/!"
)
)
	) else (
		set "temp_java_home=!JAVA_HOME!"
	)

	endlocal & set "JAVA_HOME=%temp_java_home%"

pushd ../

echo command received: %1

IF %1 EQU start goto startOp
if %1 EQU stop goto stopOp
if %1 EQU -help goto showUsage

goto showUsage

:startOp

cd..
if "%2%"=="" (SET bootseq=SERVER
) else if "%2%"=="--server" (SET bootseq=SERVER
) else if "%2%"=="--http" (SET bootseq=HTTP
) else if "%2%"=="--cluster" (SET bootseq=CLUSTER
) else if "%2%"=="--experimental" (SET bootseq=EXPERIMENTAL
) else goto showUsage

echo starting colrows process .. %2
echo clustering mode .. %bootseq%


setlocal enabledelayedexpansion
REM Read the content of jvm.options into a single string
set "jvm_options="
for /f "usebackq delims=" %%i in ("conf/jvm.options") do (
    set "jvm_options=!jvm_options! %%i"
)
REM Print the content of the jvm.options file
echo JVM Options : %jvm_options%

:: Get the directory of the currently executing batch script
set "HOME=%~dp0"
:: Remove the trailing backslash
set "HOME=%HOME:~0,-1%"
rem Get the parent of the parent directory by using the parent directory
for %%A in ("%HOME%\..") do set "HOME=%%~fA"

rem Display the parent of the parent directory
echo Parent of parent directory: %parentOfParentDir%
:: Display the directory
set "HOME=!HOME:\=/!"
echo Colrows home dir: %HOME%

echo JAVA_HOME directory: %JAVA_HOME%
echo Current directory: %CD%
start "" /B "%JAVA_HOME%/bin/java" %jvm_options% -cp "./lib/*" com.colrows.bootstrap.Colrows -bootseq %bootseq% -HOME %HOME% &
cd bin
echo Application started successfully
endlocal & set "JAVA_HOME="
echo cleanup env values %JAVA_HOME%
goto exit

:stopOp
for /f "tokens=2" %%a in ('tasklist ^| find "jps.exe") do echo process %%a
"%JAVA_HOME%/bin/jps.exe" -v>temp.txt
for /f "tokens=1" %%f in ('find "Colrows" "temp.txt"') do set str=%%f
echo str=%str%
taskkill /F /PID %str%
echo stopping colrows
goto exit

:showUsage
echo About:
echo %TAB%this script will start and stop colrows server
echo:
echo Usage:
echo %TAB%colrows.bat [COMMAND] [OPTION]
echo:
echo Commands:
echo %TAB%start   : perform a backup without re-configuring the system
echo %TAB%stop    : setup ssh and perform a backup without re-configuring the system
echo %TAB%-help   : show script uses
echo:
echo Options:
echo %TAB%--server   : start colrows as clustered server
echo %TAB%--http     : start colrows as a single instance server
echo %TAB%--cluster  : strat colrows cluster
echo %TAB%--experimental : strat colrows  as experimental server with dummy data [for single instance / default]
echo:
echo Examples:
echo %TAB%%colrows.bat start  (default it will start as server with clustering)
echo %TAB%%colrows.bat start --server
echo %TAB%%colrows.bat start --http
echo %TAB%%colrows.bat start --cluster
echo %TAB%%colrows.bat start --experimental
echo %TAB%%colrows.bat stop
goto exit

:exit
pause
